﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Controls.Grids.Primitives;

namespace TestApp
{
    public partial class MainPage : UserControl
    {
        bool canAdd = false;
        bool escape = false;
        public MainPage()
        {
            InitializeComponent();
            this.DataContext = Data.GetData(10, 20, 30);
        }

        private void XamGrid_CellExitingEditMode(object sender, Infragistics.Controls.Grids.ExitEditingCellEventArgs e)
        {
            if (e.Cell.Row is AddNewRow)
            {
                if (!canAdd)
                {
                    e.Cancel = true;
                }
                if (escape)
                {
                    e.Cell.Column.ColumnLayout.Grid.CellExitingEditMode -= XamGrid_CellExitingEditMode;
                    e.Cell.Column.ColumnLayout.Grid.ExitEditMode(true);
                    e.Cell.Column.ColumnLayout.Grid.CellExitingEditMode += XamGrid_CellExitingEditMode;           
                }

            
         
                canAdd = false;
                escape = false;
            }
    
        }

        private void XamGrid_CellControlAttached(object sender, Infragistics.Controls.Grids.CellControlAttachedEventArgs e)
        {
            if (e.Cell.Row is AddNewRow)
            {
                e.Cell.Control.KeyDown += new KeyEventHandler(Control_KeyDown);
            }
        }

        void Control_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                canAdd = true;
            }

            if (e.Key == Key.Escape)
            {
                escape = true;
            }
        }

        
    }

    public class Data : INotifyPropertyChanged
    {
        private int open;
        private int close;
        private int high;
        private int low;
        private int value;
        private string label;

        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int Open
        {
            get { return open; }
            set
            {
                open = value;
                PropChanged("Open");
            }
        }

        public int Close
        {
            get { return close; }
            set
            {
                close = value;
                PropChanged("Close");
            }
        }

        public int High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public int Low
        {
            get { return low; }
            set
            {
                low = value;
                PropChanged("Low");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Label = "Item " + i,
                    Open = r.Next(rangeStart, rangeEnd),
                    Close = r.Next(rangeStart, rangeEnd),
                    High = r.Next(rangeStart, rangeEnd),
                    Low = r.Next(rangeStart, rangeEnd),
                    Value = r.Next(rangeStart, rangeEnd),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
